/**
 Problema celor n regine pe-o tabla de shah n*n.
Se dau n regine. Se cere sa se pozitzioneze toate pe-o tabla de shah
n*n a.i. sa NU se-atace intre ele.
 Shtim k 2 regine se atak daca se afla pe aceeashi linie, coloana
sau diagonala.

Analiza problemei:
1) Organizarea shirului de solutzii shi domenii
    Dat fiind ca doua regine NU se pot pune pe-aceeashi linie,
putem conveni din start ca pe fiecare linie a tablei vom pune exact
o singura regina shi prin urmare putem defini perfect o configuratzie
a reginelor pe tabla cu urmatorul vector:
   x[k] = coloana pe care se afla regina din linia k.

 Domenii:
    x[k] apartzine de la 1 la n

2) Valid: imediat ce punem o regina pe linia k, verificam ca
aceasta sa NU se atace cu vreuna dintre cele de dinainte.
   luam i=1,k-1
    shi daca x[k]==x[i] SAU abs(x[k]-x[i])==k-i => NU este valid

3) Solutzie: k==n

4) Fara prelungire
*/
#include <iostream>
#include <cmath>
using namespace std;

int x[30],n,nrs=0;

void afish()
{
    int i;nrs++;
    cout<<"Solutzia "<<nrs<<": ";
    for(i=1;i<=n;i++)cout<<x[i]<<" ";
    cout<<"\n";
}

int valid(int k)
{
    int i;
    for(i=1;i<k;i++)
        if(x[k]==x[i]||abs(x[k]-x[i])==k-i)
            return 0;
    return 1;
}

void back(int k)
{
    for(x[k]=1;x[k]<=n;x[k]++)
        if(valid(k))
            if(k==n)afish();
            else
                back(k+1);
}

int main()
{
    cin>>n;
    back(1);
    return 0;
}
