/**
  Generatzi toate drapelurile tricolore formate cu culori distincte
dintre {alb, galben, roshu, verdghie, albastru, gri} a.i. in mijloc
sa fie una dintre culorile galben sau verdghie.
  Vetzi afisha numele culorilor cu pricina, scrise cu respectiva
culoare.
Gen:
alb galben roshu
alb galben verghie
...  (in care alb va fi scris cu alb, galben cu galben, etc.)

Analiza problemei
1) Organizarea shirului de solutzii shi domenii
    Numerotam culorile
0 - galben
1 - verdghie
2 - alb
3 - roshu
4 - albastru
5 - gri
 (A se remarca faptul ca am numerotat culorile a.i. sa avem
peste tot limita initziala egala cu 0 iar, in plus, culorile
galben shi verdghie sa fie numerotate la rind)

Domenii:
x[1] apartzine de la 0..5
x[2] apartzine de la 0..1
x[3] apartzine de la 0..5

cel mai comod d.p.d.v. practic, pentru aceste limite, este sa
le implementam printr-un vector:
     lf=(5,1,5)
prin urmare x[k] va apartzine de la 0..lf[k]

2) Valid:
    sa fie distincte.
    Cel mai la indemina implementam acest lucru cu
un vector de marcare (used[...])

3) Solutzie: k==3

4) Fara prelungire
*/
#include <iostream>
#include <windows.h>
using namespace std;

int x[10],lf[10]={0,5,1,5},used[10];

HANDLE hw=GetStdHandle(STD_OUTPUT_HANDLE);

char numec[6][15]={"galben","verdghie","alb","roshu",
            "albastru","gri"};
int codc[6]={14,10,15,12,9,8};


void afish()
{
    int i;
    for(i=1;i<=3;i++)
    {
        SetConsoleTextAttribute(hw,codc[x[i]]);
        cout<<numec[x[i]]<<" ";
    }
    cout<<"\n";
    SetConsoleTextAttribute(hw,7);
}

void back(int k)
{
    for(x[k]=0;x[k]<=lf[k];x[k]++)
        if(!used[x[k]])
        {
            used[x[k]]=1;
            if(k==3)afish();
            else back(k+1);
            used[x[k]]=0;
        }
}

int main()
{
    back(1);
    return 0;
}
